/*   Aj[VeXg  Ver 0.00   */
/*                                    */
/*                                    */
/*   by Atsushi          2000/11/23   */


import com.nttdocomo.io.ConnectionException;
import com.nttdocomo.ui.*;
import com.nttdocomo.util.*;


public class OperationCanvas extends Canvas implements TimerListener
{
	/*   ---   Field   ---   */

	private IApplication application;

	private Image image;
	private Timer timer;

	private int x,y;
	private int vx,vy;

	/*   ---   Constructor   ---   */

	public OperationCanvas(IApplication application)
	{
		this.application=application;
		
		setSoftLabel(SOFT_KEY_1,"Quit");
		
		loadImage();
		init();
		
		timer=new Timer();
		timer.setRepeat(true);
		timer.setTime(1000/20);
		timer.setListener(this);
		timer.start();
	}

	/*   ---      ---   */

	private void loadImage()
	{
		MediaImage media;
	
		try {
			media=MediaManager.getImage("resource:///chara.gif");
			media.use();
			image=media.getImage();
		}
		catch (ConnectionException e) {}
	}

	private void init()
	{
		x=0;
		y=0;
		vx=0;
		vy=0;
	}

	/*   ---   `揈   ---   */

	public void paint(Graphics g)
	{
		g.clearRect(0,0,getWidth(),getHeight());
		g.drawImage(image,x,y);
	}

	/*   ---      ---   */

	public void timerExpired(Timer source)
	{
		if ((getKeypadState() & (1<<Display.KEY_LEFT  ))!=0)
		{
			vx+=-1;
		}
		if ((getKeypadState() & (1<<Display.KEY_RIGHT ))!=0)
		{
			vx+= 1;
		}
		if (y+vy+image.getHeight()>=getHeight())
		{
			if ((getKeypadState() & (1<<Display.KEY_SELECT))!=0)
			{
				vy=-8;
			}
			else
			{
				vy=(getHeight()-image.getHeight()-y);
			}
		}
		else
		{
			vy=vy+1;
		}
		
		if (x+vx<0)
		{
			vx=(0-x);
		}
		else if (x+vx>getWidth()-image.getWidth())
		{
			vx=(getWidth()-image.getWidth()-x);
		}
		
		x+=vx;
		y+=vy;
		
		repaint();
	}

	/*   ---   Cxg   ---   */

	public void processEvent(int type,int param)
	{
		if ((type==Display.KEY_PRESSED_EVENT) && (param==Display.KEY_SOFT1))
		{
			timer.stop();
			timer.dispose();
			application.terminate();
		}
	}
}
